<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */

namespace App\Http\Services;

use App\Http\Models\PenerimaanmakananModel;
use App\Http\Models\StgpelniscmmiscrcvintModel;
use App\Http\Models\SyncUtilities\SyncHandlersModel;
use App\Http\Base\BaseService;
use Illuminate\Support\Facades\DB;

class PenerimaanmakananService extends BaseService
{
	/**
     PenerimaanmakananService constructor.
	 */
	public function __construct()
	{
		parent::__construct();
		$this->model = new PenerimaanmakananModel();
	}

	/**
	 *  index function that get all data from database by default
	 *  @return array|static[]
	 */
	public function index()
	{
		return $this->model->getQuery()->get();
	}


	/**
	 *  this function is magic pagination injector from my library you want to add new property or field you have to inject into model in alias paging property
	 *  @param array $input
	 *  @return array
	 */
	public function paging($request)
	{
		$auth = json_decode($request->session()->get('auth'));

		$this->model->joinRelationVoyageKode()->getQuery()
			->select([
				"penerimaanmakanan.mrNumber",
				"penerimaanmakanan.totalBarang",
				"penerimaanmakanan.date",
				"penerimaanmakanan.voyageStart",
				"penerimaanmakanan.voyageEnd",
				"penerimaanmakanan.id",
				"penerimaanmakanan.status",
				"voyageKode.voyageName as voyageName"
			]);

		if ($auth->aplikasi != "HO") {
			$this->model->getQuery()->where("penerimaanmakanan.kapalId", "=", $auth->kapalId);
		}

		$this->model->getQuery()->whereIn('penerimaanmakanan.mrNumber', function ($query) use ($auth) {
			$query->select('itempenerimaanmakanan.mrNumber')
				->from('itempenerimaanmakanan')
				->join("item", function ($join) {
					$join->on("item.id", "=", "itempenerimaanmakanan.itemId");
					$join->on("item.kapalId", "=", "penerimaanmakanan.kapalId");
				})
				// "item.id", "=", "itempenerimaanmakanan.itemId")
				->whereIn("item.type_id", $auth->arrCategory)
				->whereIn("itempenerimaanmakanan.locationId", $auth->arrLokasi);
		});

		$input = $request->all();
		if (!isset($input["sort"])) {
			$this->model->getQuery()->orderBy("penerimaanmakanan.date_updated", "desc");
		}
		$this->model->paging()->filter()->sorting();
		return $this->model->paging()->getPaging();
	}

	/**
	 *  get one raw row data from table by id
	 *  you can ad the relation like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->first()
	 *  or like $this->model->joinSomething()->getQuery()->where("aliastable.field","=",$value)->select(["aliastable.fieldname"])->first(); its mean you want to join an take spesific value
	 *  and you want to take value like this $model->fieldname
	 *  @param $id
	 *  @return PenerimaanmakananModel
	 */
	public function show($id)
	{
		$model = $this->model->joinRelationAccountId()->joinRelationVoyageKode()->getQuery()
			->select([
				"penerimaanmakanan.*",
				"account.namaAccount",
				"voyageKode.voyageName"
			])
			->where("penerimaanmakanan.id", "=", $id)->first();
		return $model;
	}

	public function showByTransactionNo($noTransaction)
	{
		$model = $this->model->joinRelationAccountId()->joinRelationRequesterId()->joinRelationVoyageKode()->getQuery()
			->select([
				"penerimaanmakanan.*",
				"account.namaAccount",
				"requesterId.jabatan as requesterJabatan",
				"voyageKode.voyageName"
			])
			->where("penerimaanmakanan.mrNumber", "=", $noTransaction)->first();
		return $model;
	}


	/**
	 *  this is a base function for storing data you with transaction by default
	 *  you can customization base on your business requirement as you want, you can add other object or you can to loop anc excecute the process in single process
	 *  @param array $input
	 *  @return PenerimaanmakananModel
	 *  @throws \Exception
	 */
	public function store($input)
	{
		$jlhBarang = 0;
		if (isset($input["itemID"])) {
			$jlhBarang = array_sum($input["quantity"]);
		}
		$input["totalBarang"] = $jlhBarang;
		$input["locationId"] = 1;
		$input["type"] = 1;

		$transactionBrg = new PenerimaanmakananModel();
		$transactionBrg->fill($input);
		if (!$transactionBrg->save()) {
			throw new \Exception();
		}
		return $transactionBrg->id;
	}


	/**
	 * this function will delete much data, in one action
	 * the ids is a parameter from view like 1,2,3,4 and the parameter will be exploded into single array
	 * you can remove this main alogorithm with your business requirement like soft delete or anything you want
	 *  @param $ids
	 */
	public function delete($ids)
	{
		$params = explode(".", $ids);
		$this->model->deleteBulk("id", $params);
	}


	/**
	 *  this is a base function for update and delete data by default.
	 *  you can add and custom as you want base on your requirement you can add this function as core function for handle update data from table or 
	 *  you can add multiple relation proses after update in this function 
	 *  @param $id
	 *  @param array $input 
	 *  @return PenerimaanmakananModel
	 *  @throws \Exception
	 */
	public function update($id, $input)
	{
		$penerimaanmakanan = PenerimaanmakananModel::find($id);
		$penerimaanmakanan->fill($input);
		if (!$penerimaanmakanan->update()) {
			throw new \Exception();
		}
		return $penerimaanmakanan;
	}


	/**
	 *  this function will be confirting paging property into file excel
	 *  the main library is base on excel spreadsheet library
	 *  @param array $input
	 *   @return array|static[]
	 */
	public function exportToExcel($input = array())
	{
		return $this->model->getQuery()->get();
	}


	public function getLastestID($prefix)
	{
		$getMaxID = $this->model->getQuery()->selectRaw('MAX(SUBSTRING("penerimaanmakanan"."mrNumber", 9, 6)) AS "mrNumber"')->where("penerimaanmakanan.mrNumber", "ILIKE", $prefix . "%")->first();
		if ($getMaxID || true) {
			return $prefix . substr("000000" . ($getMaxID->mrNumber + 1), -6);
		} else {
			return $prefix . "000001";
		}
	}

	public function approve($input)
	{
		$penerimaanmakanan = PenerimaanmakananModel::where("mrNumber", $input["mrNumber"]);
		$dateTimeApproved = date("Y-m-d H:i:s");
		$newInput = [
			"approverId" => $input["approverId"],
			"feedback" => $input["feedback"],
			"tglApproved" => $dateTimeApproved,
			"date_updated" => $dateTimeApproved,
			"status" => $input["status"]
		];
		if (!$penerimaanmakanan->update($newInput)) {
			throw new \Exception();
		}

		$needSync = $penerimaanmakanan->first();
		$sync = SyncHandlersModel::where("sync.local_id", "=", $needSync->id)
			->where("sync.table_name", "=", "penerimaanmakanan");
		if (!$sync->update(["need_sync" => 1])) {
			throw new \Exception();
		}

		return $penerimaanmakanan;
	}

	public function getPrepareUpdateStock($input)
	{
		$data = [];
		if (isset($input["items"]) && !empty($input["items"])) {
			foreach ($input["items"] as $row) {
				$data[] = [
					"itemId" 		=> $row->itemId,
					"kapalId" 		=> $input["kapalId"],
					"lokasiId" 		=> $row->locationId,
					"jumlah" 		=> $row->quantity,
					"satuan" 		=> "",
					"status" 		=> 1,
					"type" 			=> 2,
					"lotNumber" 	=> $row->lotNumber,
					"tglMasuk" 		=> $input["date"],
					"harga_satuan" 	=> $row->harga_satuan,

					// ADDITION FOR STOCK HISTORY
					"transaksi"		=> "penerimaanmakanan",
					"noTransaksi"	=> $input["refId"],
					"username"		=> $input["username"],
					"periode"		=> $input["date"]
				];
			}
		}
		return $data;
	}

	public function saveStaging($staging)
	{
		$data = [];
		$totalLine = count($staging["footer"]);

		foreach ($staging["footer"] as $row) {
			$data[] =  [
				"transaction_number"			=> $staging["header"]->mrNumber,
				"organization_id"				=> $staging["header"]->kapalId,
				"subinventory_code"				=> $row->namaLokasi,
				"transfer_date"					=> $staging["header"]->date,
				"voyage_call"					=> $staging["header"]->voyageKode,
				"type_misc"						=> "RCV",
				"source_code"					=> "BEGBAL",
				"process_flag"					=> 1,
				"transaction_mode"				=> 3,
				"lock_flag" 					=> 2,


				"inventory_item_id"				=> $row->itemId,
				"item_segment1"					=> $row->namaItem,
				"transaction_quantity"			=> $row->quantity,
				"transaction_uom"				=> $row->UOM,
				"transaction_date"				=> $staging["header"]->date, // $row->date_updated,
				"attribute2"					=> $row->lotNumber,
				"transaction_source_type_id"	=> 13,
				"transaction_action_id"			=> 27,

				"attribute14"                   => $staging["header"]->requesterJabatan,
				"total_line"					=> $totalLine

			];
		}

		foreach ($data as $dat) {
			$stagingModel = new StgpelniscmmiscrcvintModel();
			$stagingModel->fill($dat);
			if (!$stagingModel->save()) {
				throw new \Exception();
			}
		}
	}
}
